var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useArePackagesInstalled, } from '@deep-foundation/react-use-are-packages-installed/dist/main.js';
export function WithPackagesInstalled(param) {
    const { children, renderIfError, renderIfLoading, renderIfNotInstalled } = param, useArePackagesInstalledParams = __rest(param, ["children", "renderIfError", "renderIfLoading", "renderIfNotInstalled"]);
    const { packageInstallationStatuses, loading, error } = useArePackagesInstalled(Object.assign({}, useArePackagesInstalledParams));
    if (loading) {
        return renderIfLoading();
    }
    if (error) {
        return renderIfError(error);
    }
    if (packageInstallationStatuses === undefined) {
        return null;
    }
    const notInstalledPackageNames = Object.entries(packageInstallationStatuses)
        .filter(([packageName, isPackageInstalled]) => !isPackageInstalled)
        .map(([packageName, isPackageInstalled]) => packageName);
    if (notInstalledPackageNames.length === 0) {
        return children;
    }
    else {
        return renderIfNotInstalled(notInstalledPackageNames);
    }
}
